﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContosoTransit.WP8Library
{
    public class MockTransitService
    {
        public List<StationModel> GetStations()
        {
            return AllStations;
        }

        public LoyaltyCardModel GetLoyaltyCard(string userId)
        {
            LoyaltyCardModel card = AllCards.Where(c => c.UserId == userId).SingleOrDefault();
            return card;
        }

        public int UpdatePointsOnCheckIn(string userId, int stationId)
        {
            LoyaltyCardModel card = AllCards.Where(c => c.UserId == userId).SingleOrDefault();
            int balance = card.PointBalance;
            StationModel station = AllStations.Where(s => s.Id == stationId).SingleOrDefault();
            if (station != null)
            {
                card.StationsScanned.Add(DateTime.Now, station);

                balance += station.Points;
            }
            return balance;
        }

        public DealModel GetDealForStationCheckIn(int stationId)
        {
            DealModel deal = AllDeals.Where(d => d.stationId == stationId).SingleOrDefault();
            return deal;
        }
      
        static List<StationModel> AllStations = new List<StationModel>
        {
            new StationModel { Id=1, Name = "Main Street", 
                Message = "Next train 5 minutes", Points = 100 },
            new StationModel { Id=2, Name = "Virginia Avenue", 
                Message = "Next train 3 minutes", Points = 200  },
            new StationModel { Id=3, Name = "Tennessee Avenue", 
                Message = "Next train 10 minutes", Points = 300  },
            new StationModel { Id=4, Name = "Vermont Avenue", 
                Message = "Next train 2 minutes", Points = 400 },
            new StationModel { Id=5, Name = "Pennsylvania Avenue", 
                Message = "Next train 4 minutes", Points = 500 }
        };

        static List<LoyaltyCardModel> AllCards = new List<LoyaltyCardModel> { 
            new LoyaltyCardModel { 
            UserId = "123456", 
            Name = "John Doe", 
            PointBalance = 100,
            StationsScanned = new Dictionary<DateTime,StationModel> { 
                { DateTime.Now, AllStations[0] } }
            }
        };

        static List<DealModel> AllDeals = new List<DealModel>
        {
            new DealModel { stationId = 4, 
                Issuer = "Contoso Diner", 
                Name = "Free burger and fries", 
                Code = "ABC123", 
                LogoImagePath="Assets/Contoso_diner_logo.png", 
                QRImagePath="Assets/Contoso_diner_qr.png", 
                MerchantPhone = "888-555-2222",
                DaysValid = 14  },
            new DealModel { stationId = 5, 
                Issuer = "Contoso Transit", 
                Name = "Free ride for a day", 
                Code = "DEF456", 
                LogoImagePath="Assets/Contoso_transit_logo.png", 
                QRImagePath="Assets/Contoso_transit_qr.png", 
                MerchantPhone = "888-555-1212",
                DaysValid = 30  }
        };
    }
}
